MODULE StarWar; (* ¨  *)
IMPORT B := Basic, S := NewSupercode, Timer;

CONST
  Break = TRUE; Continue = ~Break; Delay = 50;

VAR
  zx, zy, zx1, zy1, px, py, px1, py1, prx, pry: B.Coords;
  m, s, sh: SHORTINT; (*?*)
  udg, n: INTEGER; f: BOOLEAN;

PROCEDURE Litery (y, xs, ys: SHORTINT; IN d: ARRAY OF CHAR);
(*
7200 REM -- Litery --
7210 LET x=(256-xs*8*LEN d$)/2
7220 LET a=23306: POKE a,x
7230 POKE a+1,y: POKE a+2,xs
7240 POKE a+3,ys: POKE a+4,8
7250 LET a=a+4
7260 FOR i=1 TO LEN d$
7270 POKE a+i,CODE d$(i)
7280 NEXT i
7290 POKE a+i,255
7295 RANDOMIZE USR 59033
7296 RETURN
7300 REM --
*)
BEGIN
  S.LITERY((256-(SHORT(LEN(d))-1)*xs*8) DIV 2, y, xs, ys, 8, d);
END Litery;

PROCEDURE CheckControl (): BOOLEAN; (*   *)
BEGIN
(*
 200 IF INKEY$="P" THEN LET px=px+1: GO TO 300
 210 IF INKEY$="O" THEN LET px=px-1: GO TO 300
 220 IF INKEY$="Q" THEN LET py=py-1: GO TO 300
 230 IF INKEY$="A" THEN LET py=py+1: GO TO 300
 240 IF INKEY$="M" THEN LET f=1: GO TO 300
 250 GO TO 400
*)
  Timer.Delay(Delay);
  CASE B.INKEY() OF
    "P": INC(px) |"O": DEC(px) |"Q": DEC(py) |"A": INC(py) |"M": f := TRUE;
  ELSE
    RETURN Continue
  END;

(*
 300 REM ------------
 310 IF px<0 OR px>31 OR py<0 OR py>21 THEN LET px=px1:LET py=py1: GO TO 400
 315 INK 7
 320 PRINT AT py1,px1;"E"
 330 INK 5: PRINT AT py,px;"E"
 340 LET px1=px: LET py1=py
*)
  IF (px < 0) OR (px > 31) OR (py < 0) OR (py > 21) THEN
    px := px1; py := py1; RETURN Continue
  END;
  B.INK(B.White); B.AT(py1, px1); B.PRUDG("E");
  B.INK(B.Cyan); B.AT(py, px); B.PRUDG("E");
  px1 := px; py1 := py;

(*
 345 IF f=1 THEN INK 2: PLOT 0,0:DRAW px*8+4,172-(py*8): PLOT 255,0:
     DRAW -(253-px*8),172-(py*8): RANDOMIZE USR 59342: INK 7: PLOT 0,0:
     DRAW px*8+4,172-(py*8): PLOT 255,0: DRAW -(253-px*8),172-(py*8)
 350 IF f=1 AND ((zx=px AND zy=py) OR (px=zx+1 AND py=zy) OR
     (px=zx AND py=zy+1) OR (px=zx+1 AND py=zy+1)) THEN RANDOMIZE USR 59366:
     GO TO 1000
 360 IF f=1 THEN LET f=0
*)
  IF f THEN
    B.INK(B.Red);
    B.PLOT(0, 0); B.DRAW(px*8+4, 172-(py*8));
    B.PLOT(255, 0); B.DRAW(-(253-px*8), 172-(py*8));
    S.DZWIEK_2;
    B.INK(B.White); B.PLOT(0, 0);
    B.DRAW(px*8+4, 172-(py*8));
    B.PLOT(255, 0); B.DRAW(-(253-px*8), 172-(py*8));
  END;
  IF f & (((zx=px) & (zy=py)) OR ((px=zx+1) & (py=zy)) OR
     ((px=zx) & (py=zy+1)) OR ((px=zx+1) & (py=zy+1))) THEN
    S.DZWIEK_2; RETURN Break
  END;
  IF f THEN f := FALSE END;
  RETURN Continue
END CheckControl;

PROCEDURE GameLoop; (* 200-500:    *)
BEGIN
  LOOP
    IF CheckControl() = Break THEN EXIT END;

(*
 400 REM ------------
 410 IF s=sh THEN LET s=0: LET sh=INT (RND*5+4): LET prx=SGN (RND*2-1):
     LET pry=SGN (RND*2-1)
 420 LET s=s+1
 422 LET zx=zx+prx: LET zy=zy+pry
 425 IF zx<1 OR zx>29 OR zy<1 OR zy>19 THEN LET zx=zx1: LET zy=zy1: GO TO 200
 440 INK 7
 450 PRINT AT zy1,zx1;"AB"
 460 PRINT AT zy1+1,zx1;"CD"
 470 INK 6: PRINT AT zy,zx; "AB"
 480 PRINT AT zy+1,zx;"CD"
 490 LET zx1=zx: LET zy1=zy
 500 GO TO 200
*)
    IF s = sh THEN
      s := 0;
      sh := SHORT(B.RND(4, 8));
      prx := B.SGN(B.RND(-1, 0)); IF prx = 0 THEN prx := 1 END;
      pry := B.SGN(B.RND(-1, 0)); IF pry = 0 THEN pry := 1 END;
    END;
    INC(s); INC(zx, prx); INC(zy, pry);
    IF (zx < 1) OR (zx > 29) OR (zy < 1) OR (zy > 19) THEN
      zx := zx1; zy := zy1;
    ELSE
      B.INK(B.White);
      B.AT(zy1, zx1); B.PRUDG("A"); B.PRUDG("B");
      B.AT(zy1+1, zx1); B.PRUDG("C"); B.PRUDG("D");
      B.INK(B.Olive);
      B.AT(zy, zx); B.PRUDG("A"); B.PRUDG("B");
      B.AT(zy+1, zx); B.PRUDG("C"); B.PRUDG("D");
      zx1 := zx; zy1 := zy;
    END;
  END(*LOOP*)
END GameLoop;

BEGIN (*$MAIN*)
(*
  10 CLEAR 46945
  12 POKE 23658,8
  15 BORDER 0: PAPER 0: INK 7
  20 CLS
*)
  B.Init;
  B.POKE(23658, 8); (*     *)
  B.BORDER(B.Black); B.PAPER(B.Black); B.INK(B.White);

(*
  30 GO SUB 7000
  40 GO SUB 7100
*)
(*
7000 REM -Graphics-
7010 FOR n=0 TO 39
7020 READ s
7030 POKE USR "A"+n,s
7040 NEXT n
7050 DATA 0,64,64,64,35,39,39,30
7060 DATA 0,2,2,2,196,228,228,120
7070 DATA 30,39,39,35,64,64,64,0
7080 DATA 120,228,228,196,2,2,2,0
7090 DATA 16,16,16,238,16,16,16,0
7095 RETURN
*)
  B.DEFDATA(udg, 8*5);
  B.DATA8(0,64,64,64,35,39,39,30);
  B.DATA8(0,2,2,2,196,228,228,120);
  B.DATA8(30,39,39,35,64,64,64,0);
  B.DATA8(120,228,228,196,2,2,2,0);
  B.DATA8(16,16,16,238,16,16,16,0);
  B.UDG(udg);
  B.POKE(5C7BH, udg MOD 256); B.POKE(5C7CH, udg DIV 256);
  (*Graphics;*) (*LoadCode;*)

(*
  50 CLS
*)
  LOOP
    B.CLS;

(*
  60 LET y=0: LET xs=3: LET ys=20: LET d$="SPACE WAR":
     INK 2: BRIGHT 1: GO SUB 7200
  70 LET y=160: LET xs=1: LET ys=2: LET d$="PRESS ANY KEY TO START":
     INK 6: GO SUB 7200
  80 IF INKEY$="" THEN GO TO 80
  90 BRIGHT 0
 100 RANDOMIZE USR 59366
 110 BORDER 0
*)
    B.BRIGHT(B.On); B.INK(B.LightRed); Litery(0, 3, 20, "SPACE WAR");
    B.INK(B.Yellow); Litery(160-256, 1, 2, "PRESS ANY KEY TO START");
    REPEAT UNTIL B.INKEY() # B.NoKeys;
    B.BRIGHT(B.Off);
    S.DZWIEK_3;
    B.BORDER(B.Black);

(*
 120 REM -------------
 125 CLS
 130 LET d$="O-LEFTP-RIGHT": LET y=10: LET xs=2:LET ys=5: GO SUB 7200
 140 LET d$="Q-UPA-DOWN ": LET y=60: LET xs=2:LET ys=5: GO SUB 7200
 150 LET d$="M-FIRE": INK 2: LET y=110: LET xs=4: LET ys=5:GO SUB 7200
 160 IF INKEY$="" THEN GO TO 160
*)
    B.CLS;
    Litery(10, 2, 5, "O-LEFT   P-RIGHT");
    Litery(60, 2, 5, "Q-UP     A-DOWN ");
    B.INK(B.Red); Litery(110, 4, 5, "M-FIRE");
    REPEAT UNTIL B.INKEY() # B.NoKeys;

(*
 170 REM -----------
 172 LET s=0: LET sh=0
 175 INK 7: CLS : OVER 1
 176 FOR N=1 TO 200: PLOT RND*255,RND*175: NEXT N
 177 PRINT AT 10,15;"E"
*)
    s := 0; sh := 0;
    B.INK(B.White); B.CLS; B.OVER(B.On);
    FOR n := 200 TO 1 BY -1 DO B.PLOT(B.RND(0, 255), B.RND(0, 175)) END;
    B.AT(10, 15); B.PRUDG("E");

(*
 179 INK 3: PLOT 0,0: DRAW 0,175: DRAW 255,0: DRAW 0,-175: DRAW -255,0
 180 LET zx=INT (RND*30): LET zy=INT (RND*20)
 185 LET zx1=zx: LET zy1=zy
 186 PRINT AT zy,zx;"AB": PRINT AT zy+1,zx;"CD"
 190 LET px=15: LET py=10
 195 LET px1=px: LET py1=py
 197 LET f=0
*)
    B.INK(B.Magenta); B.PLOT(0, 0);
    B.DRAW(0, 175); B.DRAW(255, 0); B.DRAW(0, -175); B.DRAW(-255, 0);
    zx := SHORT(B.RND(0, 29)); zy := SHORT(B.RND(0, 19));
    zx1 := zx; zy1 := zy;
    B.AT(zy, zx); B.PRUDG("A"); B.PRUDG("B");
    B.AT(zy+1, zx); B.PRUDG("C"); B.PRUDG("D");
    px := 15; py := 10;
    px1 := px; py1 := py;
    f := FALSE;

(* 200-500 *)
    GameLoop;

(*
1000 REM ------------
1010 PAPER 0: BORDER 0: CLS
1015 FOR M=1 TO 10
1020 FOR N=1 TO 250 STEP 40: POKE 57399,N: RANDOMIZE USR 57392: NEXT N
1030 NEXT M
1040 GO TO 50
*)
    B.PAPER(B.Black); B.BORDER(B.Black); B.CLS;
    FOR m := 10 TO 1 BY -1 DO
      FOR n := 1 TO 241 BY 40 DO S.EKRAN_2(n) END;
    END;
  END(*LOOP*)

(*
7100 REM -- LOAD code --
7110 INK 0: PAPER 0: PRINT AT 0,0;
7120 LOAD ""CODE
7122 INK 7: LET d$="LOADING": LET y=50: LET xs=2: LET ys=10: GO SUB 7200
7123 LET d$="PLEASE WAIT": LET y=130: LET xs=2: LET ys=1:INK 3: GO SUB 7200
7130 INK 0: PRINT AT 0,0;: LOAD ""CODE
7140 PRINT AT 0,6;: LOAD ""CODE
7145 PRINT AT 0,0;: LOAD ""CODE
7150 RETURN
*)
  (*B.Quit;*)
END StarWar.